package de.fzj.unicore.ucc.runner;

import org.ggf.schemas.jsdl.x2005.x11.jsdl.OperatingSystemType;
import org.ggf.schemas.jsdl.x2005.x11.jsdl.OperatingSystemTypeEnumeration;
import org.unigrids.x2006.x04.services.tss.TargetSystemPropertiesDocument.TargetSystemProperties;

//TODO handle extensibility as defined in JSDL...
public class OSRequirement implements Requirement {

	private final OperatingSystemTypeEnumeration.Enum os;
	
	public OSRequirement(OperatingSystemTypeEnumeration.Enum os){
		this.os=os;
	}
	
	public String getDescription() {
		return "Operating system: "+os;
	}

	public boolean isFulfilled(TargetSystemProperties properties) {
		try{
			OperatingSystemType ost=properties.getOperatingSystem();
			if(ost==null)return true;
			return os.equals(ost.getOperatingSystemType().getOperatingSystemName());
		}catch(Exception e){
			e.printStackTrace();
		}
		return false;
	}
	
	@Override
	public int hashCode() {
		int result = 1;
		result = 31 * result + ((os == null) ? 0 : os.toString().hashCode());
		return result;
	}

	@Override
	public boolean equals(Object o){
		if(o==null || ! (o instanceof OSRequirement)) return false;
		return os.equals( ((OSRequirement)o).os );
	}
}
