package de.fzj.unicore.ucc.runner;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;

import de.fzj.unicore.uas.client.TSSClient;

/**
 * randomly choose a site
 */
public class RandomSelection implements SiteSelectionStrategy{

	private static Random random=new Random();
	
	private Map<String, Integer>selected=new HashMap<String, Integer>();
	
	public TSSClient select(List<TSSClient> available) {
		TSSClient selectedTSS=available.get(random.nextInt(available.size()));
		String name=selectedTSS.getTargetSystemName();
		synchronized(this){
			Integer val=selected.get(name);
			if(val!=null)val++;
			else val=1;
			selected.put(name, val);
		}
		return selectedTSS;
	}
	
	public Map<String,Integer>getSelectionStatistics(){
		return selected;
	}
}