package de.fzj.unicore.ucc;

import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertTrue;
import static org.junit.Assert.fail;

import org.junit.Test;

import de.fzj.unicore.ucc.helpers.EndProcessingException;
import de.fzj.unicore.ucc.util.MockCommand;
import de.fzj.unicore.ucc.util.MockLoadClass;

public class TestUCC {

	@Test
	public void test_ExtendUCC(){
		System.setProperty(UCC.UCC_EXTENSIONS, "src/test/resources/conf/extensions");
		UCC.loadUserActions();
		Command cmd=UCC.getCommand("test-extension");
		assertNotNull(cmd);
		assertTrue(cmd.getClass().getName().equals(MockCommand.class.getName()));
		assertTrue(MockLoadClass.loaded);
	}

	@Test
	public void test_PrintUsage(){
		UCC.printUsage(false);
		System.err.println("\n");
		UCC.printAuthNUsage();
	}

	@Test
	public void test_ShowHelp(){
		UCC.mute=true;
		String[]args=new String []{"-h"};
		try{
			for(Command cmd: UCC.getAllCommands()){
				try{
					cmd.init(args);
				}catch(EndProcessingException epe){}
			};
		}catch(Exception ex){
			ex.printStackTrace();
			fail();
		}
		args=new String []{"help-auth"};
		UCC.main(args);
		UCC.mute=false;
	}
	
	@Test
	public void test_LoadAuthNMethods(){
		assertNotNull(UCC.getAuthNMethod("X509"));
	}
	
}
