package de.fzj.unicore.ucc.actions;

import static org.junit.Assert.assertEquals;

import org.junit.Test;

import de.fzj.unicore.ucc.UCC;
import de.fzj.unicore.ucc.util.EmbeddedTestBase;
import de.fzj.unicore.ucc.util.KeystoreAuthNWithPasswd;
import eu.unicore.bugsreporter.annotation.FunctionalTest;

/**
 * Functional tests for the UCC actions. 
 * These run against an embedded UNICORE instance.
 */
public class TestActionsWithoutPassword extends EmbeddedTestBase {
	
	@Override
	protected void connect(){
		UCC.main(new String[]{"connect", "-k", "X509Test", "-c","src/test/resources/conf/userprefs.nopasswd"});
		assertEquals(Integer.valueOf(0),UCC.exitCode);
	}

	@FunctionalTest(id="testNoPassword", description="Tests few UCC operations without credential and truststore password in properties file")
	@Test
	public void testCreateUspace(){
		KeystoreAuthNWithPasswd.QUESTIONS=0;
		connect();
		assertEquals(2, KeystoreAuthNWithPasswd.QUESTIONS);
		String[] args=new String[]{"run", "-k", "X509Test",
				"-c", "src/test/resources/conf/userprefs.nopasswd",
				"src/test/resources/jobs/date.u",
		};
		UCC.main(args);
		assertEquals(Integer.valueOf(0),UCC.exitCode);
		assertEquals(4, KeystoreAuthNWithPasswd.QUESTIONS);
		
		args=new String[]{"wsrf", "getproperties", "-k", "X509Test",
				"-c", "src/test/resources/conf/userprefs.nopasswd",
				Run.getLastJobAddress(),
		};
		UCC.main(args);
		assertEquals(Integer.valueOf(0),UCC.exitCode);
		assertEquals(6, KeystoreAuthNWithPasswd.QUESTIONS);
	}

}
