package de.fzj.unicore.ucc.util;

import java.util.Properties;

import de.fzj.unicore.ucc.Constants;
import de.fzj.unicore.ucc.authn.Authentication;
import eu.unicore.security.canl.CachingPasswordCallback;
import eu.unicore.security.canl.CredentialProperties;
import eu.unicore.security.canl.PasswordCallback;
import eu.unicore.security.canl.TruststoreProperties;
import eu.unicore.security.xfireutil.client.XFireClientFactory;
import eu.unicore.util.httpclient.ClientProperties;
import eu.unicore.util.httpclient.IClientConfiguration;

public class KeystoreAuthNWithPasswd implements Authentication, Constants {

	public static final String X509="X509Test";
	
	public static int QUESTIONS = 0;
	
	@Override
	public String getName() {
		return X509;
	}

	@Override
	public String getDescription() {
		return "Test authn provider with callback";
	}
	
	@Override
	public void printUsage(){
		System.out.println("unit testing only");
	}
	
	@Override
	public IClientConfiguration initSecurityProperties(Properties properties){

		ClientProperties sp=new ClientProperties(properties, getPasswordCallback(), 
				TruststoreProperties.DEFAULT_PREFIX, 
				CredentialProperties.DEFAULT_PREFIX, ClientProperties.DEFAULT_PREFIX);
		
		//message logging
		String logOut=properties.getProperty(XFireClientFactory.LOG_OUTGOING);
		if(logOut!=null)sp.getExtraSettings().setProperty(XFireClientFactory.LOG_OUTGOING, logOut);
		String logIn=properties.getProperty(XFireClientFactory.LOG_INCOMING);
		if(logIn!=null)sp.getExtraSettings().setProperty(XFireClientFactory.LOG_INCOMING, logIn);

		return sp;
	}
	

	private PasswordCallback getPasswordCallback() {
		return new CachingPasswordCallback()
		{
			@Override
			public boolean ignoreProperties() {
				return false;
			}
			
			@Override
			public char[] getPasswordFromUser(String protectedArtifactType, String protectedArtifactDescription) {
				QUESTIONS++;
				return "the!user".toCharArray();
			}
			
			@Override
			public boolean askForSeparateKeyPassword() {
				return false;
			}
		};
	}
}
