package de.fzj.unicore.ucc.util;

import static org.junit.Assert.assertTrue;

import java.net.InetAddress;
import java.net.NetworkInterface;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Enumeration;
import java.util.List;

import org.ggf.schemas.jsdl.x2005.x11.jsdl.JobDefinitionDocument;
import org.junit.Test;
import org.unigrids.services.atomic.types.GridFileType;

import de.fzj.unicore.ucc.actions.LS;

public class TestVarious {

	@Test
	public void test1(){
		GridFileType f= GridFileType.Factory.newInstance();
		f.setIsDirectory(true);
		f.setPath("foo");
		f.setSize(1234);
		Calendar c=Calendar.getInstance();
		f.setLastModified(c);
		f.addNewPermissions().setExecutable(true);
		LS ls=new LS();
		String reply=ls.detailedListing(f);
		assertTrue(reply.contains("foo"));
		assertTrue(reply.contains("1234"));
		assertTrue(reply.contains("d--x"));
		assertTrue(reply.contains(ls.format(c)));
	}

	public void test2(){

		JobDefinitionDocument jsdl=JobDefinitionDocument.Factory.newInstance();
		jsdl.addNewJobDefinition();

	}

	@Test
	public void test3()throws Exception{
		System.out.println(getFullyQualifiedHostName());
	}



	private static String getFullyQualifiedHostName()
	{
		try {
			String canonical = "";
			Enumeration<NetworkInterface> enet = NetworkInterface.getNetworkInterfaces();
			List<String> names = new ArrayList<String>();
			while ( enet.hasMoreElements())
			{
				NetworkInterface net = enet.nextElement();
				if ( net.isLoopback() )
					continue;

				Enumeration<InetAddress> eaddr = net.getInetAddresses();
				while ( eaddr.hasMoreElements() )
				{
					InetAddress inet = eaddr.nextElement();

					if ( inet.getCanonicalHostName().equalsIgnoreCase( inet.getHostAddress() ) )
						continue;
					else
					{
						names.add(inet.getCanonicalHostName());
					}
				}
			}


			canonical = InetAddress.getLocalHost().getCanonicalHostName();
			if(canonical != null)
			{
				for(String name : names)
				{
					if(name.startsWith(canonical)) return name; 
				}
				return names.isEmpty() ? canonical : names.get(0); 
			}
			else
			{
				return names.isEmpty() ? "localhost" : names.get(0); 
			}

		} catch (Exception e) {
			return "localhost";
		}

	}
}
