package de.fzj.unicore.ucc.bes;


import org.ggf.schemas.bes.x2006.x08.besFactory.TerminateActivitiesResponseType;
import org.ggf.schemas.bes.x2006.x08.besFactory.TerminateActivityResponseType;
import de.fzj.unicore.bes.faults.UnknownActivityIdentifierFault;


public class TerminateJob extends BaseActionState {


	@Override
	public void process() {
		super.process();
		terminate();
	}

	@Override
	public String getName() {
		return "bes-terminate-job";
	}


	@Override
	public String getArgumentList() {
		return "<jobfile>";
	}

	@Override
	public String getSynopsis() {
		return "Terminate BES job using a job properties file.";
		
	}

	@Override
	public String getDescription() {
		return "terminate bes activity";
	}

	protected void terminate() {
		TerminateActivitiesResponseType termType = null;
		try {
			termType = factory.terminateActivity(activityEpr);
		} catch (UnknownActivityIdentifierFault e) {
			error("Couldn't find the specified activity. ", e);
			endProcessing();
		}
		StringBuilder sb = new StringBuilder();
		TerminateActivityResponseType tt = termType.getResponseArray()[0];

		if (tt.getTerminated())
			sb.append("Job is cancelled.");
		else {
			if (tt.getFault() != null)
				sb.append(termType.getResponseArray()[0].getFault()
						.getFaultstring());
			else
				sb.append("Job will eventually be cancelled.");
		}

		message(sb.toString());
	}
	
	@Override
	public String getCommandGroup() {
		return BESUCCConstants.BES_COMMAND_GROUP;
	}
}
