package de.fzj.unicore.ucc.bes;

import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertTrue;
import static org.junit.Assert.fail;

import java.util.Iterator;
import java.util.List;

import org.junit.Test;
import org.w3.x2005.x08.addressing.EndpointReferenceType;

import de.fzj.unicore.bes.client.FactoryClient;
import de.fzj.unicore.wsrflite.xmlbeans.client.IRegistryQuery;
import de.fzj.unicore.wsrflite.xmlbeans.client.RegistryClient;

public class TestBESFactoryLister extends EmbeddedTestBase {
	
	
	@Test
	public void testListBESFactories(){
		
		String registryUrl = uas.getKernel().getContainerProperties().getBaseUrl()+"/Registry?res=default_registry";
		
		IRegistryQuery registry;
		
		EndpointReferenceType epr=EndpointReferenceType.Factory.newInstance();
		epr.addNewAddress().setStringValue(registryUrl);
		
		try {
			registry = new RegistryClient(registryUrl, epr, uas.getKernel().getClientConfiguration());
			
			List<FactoryClient> list = new BESFactoryLister(registry,uas.getKernel().getClientConfiguration()).list();

			assertTrue(list.size() > 0);
			
			for (Iterator<FactoryClient> iterator = list.iterator(); iterator.hasNext();) {
				FactoryClient fc = iterator.next();
				assertNotNull(fc.getFactoryResourceAttributes().getFactoryResourceAttributesDocument());
			}
			
		} catch (Exception e) {
			fail();
		}
		
			
	}
	
}
