package de.fzj.unicore.ucc.testsuite.util;

import org.json.JSONArray;
import org.json.JSONObject;

/**
* helper class that wraps the info about a pre/post processing groovy script
*/ 

public class Script {

  File script
  
  def parameters=[:]

  Binding binding

  public Script(){
     binding=new Binding()
  }

  //build scripts from the given JSON array
  //entries in the JSON are expected to be of the form { Script: "...", param_a: "value_a", param_b: "value_b", ... }  
  public static List build(JSONArray scriptListSpec){
     def result = []
     for(int i=0; i<scriptListSpec.length(); i++){
  	    def it=scriptListSpec.get(i)
  	 	result+=build(it)
  	 }
  	 return result
  }

  //build single script
  public static Script build(JSONObject scriptSpec){
    Script s=new Script()
    scriptSpec.keys().each{ 
      if(it.equals("Script")){
          s.script=new File(scriptSpec.optString(it)).absoluteFile
      }
      else{
          s.parameters.put(it, scriptSpec.optString(it))
      }
    }
    return s
  }


  //execute the script
  public String run(){
  	GroovyShell shell = new GroovyShell(binding);
	String log=""
	binding.setVariable("log",log)
	try{
		shell.evaluate(script);
		log = binding.getVariable("log");
	}catch(AssertionError ae){
		//TODO better reporting
		println("Assertion in post-condition failed: "+ae.getMessage());
		log="Assertion in post-condition failed: "+ae.getMessage();
	}
	return log	
 }

}

