package de.fzj.unicore.ucc.testsupport;

import java.io.InputStream;

import org.apache.commons.io.IOUtils;

import de.fzj.unicore.ucc.actions.Groovy;

public class RunTest extends Groovy {

	String getExpression(){
		return expression;
	}
	
	/**
	 * load default TestRunner.groovy script from classpath
	 */ 
	@Override
	public void getFallbackGroovyExpression(){
		try{
			String res="/TestRunner.groovy";
			InputStream is=getClass().getResourceAsStream(res);
			if(is==null)throw new IllegalStateException("Expected resource '"+res+"' not found!");
			expression=IOUtils.toString(is);
			if(expression==null)throw new IllegalStateException("Expected resource '"+res+"' not found!");
		}catch(Exception e){
			throw new RuntimeException(e);
		}
	}

	@Override
	public String getName() {
		return "run-test";
	}

	@Override
	public String getSynopsis() {
		return "Runs a test. A custom test executor script written in " +
				"Groovy can be defined using the '-f' or '-e' option. " +
				"The built-in script expects the name of a test definition file " +
				"passed via the command line.";	}

	@Override
	public String getDescription() {
		return "runs a test";
	}

	@Override
	public String getArgumentList() {
		return "test_definition_file";
	}
	
	
	
}
