package de.fzj.unicore.ucc.testsupport;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;

import org.junit.Test;

import de.fzj.unicore.ucc.UCC;

public class TestCommand{

	@Test
	public void testLoadDefaultScript(){
		RunTest c=new RunTest();
		c.getFallbackGroovyExpression();
		String expr=c.getExpression();
		assertNotNull(expr);
	}
	
	@Test
	public void testHelp(){
		UCC.unitTesting=true;
		String[]args={"run-test","-h", "-v",
				"-c","src/test/resources/preferences",
		};
		UCC.main(args);
		assertEquals((Integer)0,UCC.exitCode);
	}

	@Test
	public void testSingle(){
		UCC.unitTesting=true;
		String[]args={"run-test","src/test/resources/example.test", "-v",
				"-c","src/test/resources/preferences",
		};
		UCC.main(args);
		assertEquals((Integer)0,UCC.exitCode);
	}

	@Test
	public void testSuite(){
		UCC.unitTesting=true;
		variable1=0;
		variable2=0;
		String[]args={"run-test","src/test/resources/suite.test", "-v",
				"-c","src/test/resources/preferences",	
		};
		UCC.main(args);
		assertEquals((Integer)0,UCC.exitCode);
		
		//check number of executions as defined in suite.test
		assertEquals(4,variable1);
		assertEquals(2,variable2);
	}
	
	public static int variable1=0; 
	public static int variable2=0;
}
